/**
 * sdbe.admin.js
 *
 * @author SaurabhSharma
 * @version 1.1.0
 */
jQuery(function ($) {

    'use strict';

    // Generate table for scripts
    function sdbe_scripts_table() {
        var tr = $('table#sdbe-scripts-table tr:not(:nth-child(1))'),
            dq_li = $('#sdbe-scripts-for-dequeue > li:not(.no-script)'),
            dq_val = $('#sdequeuerbe_options\\[sdbe_scripts_selected\\]'),
            dq_wrap = $('#scbe-dequeue-wrap'),
            dqed_ul = $('#sdbe-scripts-dequeued'),
            dqed_wrap = $('#scbe-dequeued-wrap'),
            failed_ul = $('#sdbe-scripts-not-dequeued'),
            failed_wrap = $('#scbe-notdequeued-wrap'),
            sel_all_tr = $('#select-all-scripts-be'),
            sel_all_dqed = $('#select-dq-scripts-be'),
            dq_count = $('#script-dequeue-count-be'),
            dqed_count = $('#script-dequeued-count-be'),
            failed_count = $('#script-notdequeued-count-be');

        selectable_table_be(tr, dq_li, dq_val, dq_wrap, dqed_ul, dqed_wrap, failed_ul, failed_wrap, sel_all_tr, sel_all_dqed, dq_count, dqed_count, failed_count);
    }

    // Generate table for stylesheets
    function sdbe_styles_table() {
        var tr = $('table#sdbe-styles-table tr:not(:nth-child(1))'),
            dq_li = $('#sdbe-styles-for-dequeue > li:not(.no-script)'),
            dq_val = $('#sdequeuerbe_options\\[sdbe_styles_selected\\]'),
            dq_wrap = $('#stbe-dequeue-wrap'),
            dqed_ul = $('#sdbe-styles-dequeued'),
            dqed_wrap = $('#stbe-dequeued-wrap'),
            failed_ul = $('#sdbe-styles-not-dequeued'),
            failed_wrap = $('#stbe-notdequeued-wrap'),
            sel_all_tr = $('#select-all-styles-be'),
            sel_all_dqed = $('#select-dq-styles-be'),
            dq_count = $('#style-dequeue-count-be'),
            dqed_count = $('#style-dequeued-count-be'),
            failed_count = $('#style-notdequeued-count-be');

        selectable_table_be(tr, dq_li, dq_val, dq_wrap, dqed_ul, dqed_wrap, failed_ul, failed_wrap, sel_all_tr, sel_all_dqed, dq_count, dqed_count, failed_count);
    }

    // Creates table with selectable rows
    function selectable_table_be(tr, dq_li, dq_val, dq_wrap, dqed_ul, dqed_wrap, failed_ul, failed_wrap, sel_all_tr, sel_all_dqed, dq_count, dqed_count, failed_count) {
        var sc_arr = [],
            sc_final = [],
            sc_final_selected = [],
            sc_dq_arr_tmp = [],
            sc_dq_arr = [],
            sc_dq_final = [],
            sc_failed,
            sc_failed_li = '',
            sc_success,
            sc_success_li = '',
            tog1 = 0,
            tog2 = 0,
            sc_tmp_arr = [];

        // Store detected files
        if (tr.length) {
            tr.each(function () {
                if ($(this).data('handle')) {
                    sc_arr.push($(this).data('handle'));
                }
            });
        }

        // Show list of files added to dequeue
        if (dq_li.length) {
            dq_li.each(function () {
                sc_dq_arr_tmp.push($(this).data('handle'));
            });

            // Remove duplicates
            $.each(sc_dq_arr_tmp, function (i, el) {
                if ($.inArray(el, sc_dq_arr) === -1) sc_dq_arr.push(el);
            });

            $(dq_wrap).fadeIn();
        }

        // Find files which were not dequeued
        sc_failed = $.grep(sc_arr, function (i) {
            return $.inArray(i, sc_dq_arr) != -1;
        });

        // Find files which were dequeued successfully
        sc_success = $.grep(sc_dq_arr, function (i) {
            return $.inArray(i, sc_failed) == -1;
        });

        // Show successfully dequeued files list
        if (sc_success.length) {
            $(sc_success).each(function () {
                sc_success_li += '<li data-handle="' + this + '">' + this + '</li>';
            });
            $(dqed_ul).html(sc_success_li);
            $(dqed_wrap).fadeIn();
        }

        // Show failed files list
        if (sc_failed.length) {
            $(sc_failed).each(function () {
                sc_failed_li += '<li data-handle="' + this + '">' + this + '</li>';
            });
            $(failed_ul).html(sc_failed_li);
            $(failed_wrap).fadeIn();
        }

        // Store dequeue list for use in php
        if ($(dq_val).val()) {
            sc_dq_final = $(dq_val).val().split(',');
        }


        // Selectable rows
        if (tr.length) {
            $(tr).each(function () {
                var handle = $(this).data('handle');
                $(this).removeClass('tr-error');
                if ($.inArray(handle, sc_failed) !== -1) {
                    $(this).addClass('tr-error');
                }
            });

            $(tr).on('click', function () {
                var handle = $(this).data('handle');

                // Enable selection only if the file is not in failed files list
                if ($.inArray(handle, sc_failed) === -1) {
                    $(this).toggleClass('tr-selected');
                }

                $(document).trigger('scripts-be-table-changed');
            });

        } // tr.length

        // Selectable dequeue list
        $(dq_li).on('click', function () {
            $(this).toggleClass('tr-selected');
            $(document).trigger('sc-be-dq-list-changed');
        });

        // Select all detected scripts
        $(sel_all_tr).on('click', function (e) {
            e.preventDefault();
            if (tog1 % 2 === 0) {
                $(tr).not('.tr-error, .table-head').addClass('tr-selected');
            } else {
                $(tr).not('.tr-error, .table-head').removeClass('tr-selected');
            }
            tog1++;

            $(document).trigger('scripts-be-table-changed');
        });

        // Select all dequeued scripts
        $(sel_all_dqed).on('click', function (e) {
            e.preventDefault();
            if (tog2 % 2 === 0) {
                $(dq_li).addClass('tr-selected');
            } else {
                $(dq_li).removeClass('tr-selected');
            }
            tog2++;

            $(document).trigger('sc-be-dq-list-changed');
        });

        // Generate final dequeue list after all kind of selection/deselection
        $(document).on('scripts-be-table-changed sc-be-dq-list-changed', function (e) {

            if (e.type == 'scripts-be-table-changed') {
                sc_final = [];
                if (tr.length) {
                    $(tr).each(function () {
                        var handle = $(this).data('handle');
                        if ($(this).hasClass('tr-selected')) {
                            sc_final.push(handle);
                        } else {
                            sc_final = $.grep(sc_final, function (value) {
                                return value != handle;
                            });
                        }
                    });
                }

            } else if (e.type == 'sc-be-dq-list-changed') {
                sc_dq_final = [];
                if (dq_li.length) {
                    $(dq_li).each(function () {
                        var handle = $(this).data('handle');
                        if ($(this).hasClass('tr-selected')) {
                            sc_dq_final = $.grep(sc_dq_final, function (value) {
                                return value != handle;
                            });
                        } else {
                            sc_dq_final.push(handle);
                        }
                    });
                }
            }

            sc_final_selected = [];

            sc_final_selected = $.merge($.merge([], sc_final), sc_dq_final);

            // Remove duplicates
            sc_tmp_arr.length = 0;
            $.each(sc_final_selected, function (i, el) {
                if ($.inArray(el, sc_tmp_arr) === -1) sc_tmp_arr.push(el);
            });

            // Store the list for use in php
            $(dq_val).val(sc_tmp_arr.join(','));
        });

        // Update counts
        $(dq_count).html(sc_dq_arr.length);
        $(dqed_count).html(sc_success.length);
        $(failed_count).html(sc_failed.length);
    }

    // Generate Script and Styles table
    $(function() {
        sdbe_scripts_table();
        sdbe_styles_table();
    });

    // Settings tab navigation
    function sd_be_tabs() {
        $('.sd-tabs > li > a').on('click', function (e) {
            e.preventDefault();
            var clicked_group = $(this).attr('href');
            $(this).parent().parent().find('> li > a').removeClass('sd-tab-active');
            $(this).addClass('sd-tab-active').blur();
            $(this).parent().parent().parent().find('> .sd-tabbed-content').removeClass('first').hide();
            $(clicked_group).show();
        });
    }

    sd_be_tabs();

}); //$